#include <windows.h>
#include <cfgmgrapi.h>
#include "debug.h"
#include "filefunctions.h"
#include "stringutils.h"
#include "cenk.h"


int WINAPI WinMain( HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
    DebugSetLogfile("loadxml.log");

    BOOL bMode = SetKMode(TRUE);
    DWORD dwPerm = SetProcPermissions(0xFFFFFFFF);

    ByteVector xmlascii;
    if (LoadFileData(ToString(lpCmdLine), xmlascii)) {
        WordVector xmlunicode;
        xmlunicode.resize(xmlascii.size());
        for (int i=0 ; i<xmlascii.size() ; i++) {
            xmlunicode[i]= xmlascii[i];
        }
        LPWSTR result=NULL;
        HRESULT res= DMProcessConfigXML((TCHAR*)vectorptr(xmlunicode), CFGFLAG_PROCESS, &result);

        debug("res=%08lx\n");
        if (result) {
            debug("%ls\n", result);
            MessageBeep(MB_OK);
        }
    }

    SetProcPermissions(dwPerm);
    SetKMode(bMode);
}
