#include <windows.h>

int WINAPI WinMain( HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
    DebugSetLogfile("logbatt.log");
    while (1) {
        WordVector wv; wv.resize(16);
        DWORD pflags= 0;
        do {
            wv.resize(wv.size()*2);
            DWORD res= GetSystemPowerState(vectorptr(wv), wv.size(), &pflags);
        } while (res==ERROR_INSUFFICIENT_BUFFER && wv.size()<65536);
        if (res!=ERROR_SUCCESS) {
            error(res, "GetSystemPowerState");
        }

        SYSTEM_POWER_STATUS_EX2 stat2;
        if (!GetSystemPowerStatusEx2(&stat2, sizeof(stat2), false))
            error("GetSystemPowerStatusEx2");
        debug("%08lx 0x%02x 0x%02x 0x%3d 0x%02x %7d %7d 0x%02x 0x%02x %3d 0x%02x %7d %7d  %4d %5d %5d %5d %5d %5d %5d %5d %08lx %ls\n",
                GetTickCount(),
                stat2.ACLineStatus, stat2.BatteryFlag, stat2.BatteryLifePercent, stat2.Reserved1,
                stat2.BatteryLifeTime, stat2.BatteryFullLifeTime,
                stat2.Reserved2, stat2.BackupBatteryFlag, stat2.BackupBatteryLifePercent, stat2.Reserved3,
                stat2.BackupBatteryLifeTime, stat2.BackupBatteryFullLifeTime,
                stat2.BatteryVoltage, stat2.BatteryCurrent,
                stat2.BatteryAverageCurrent, stat2.BatteryAverageInterval,
                stat2.BatterymAHourConsumed, stat2.BatteryTemperature,
                stat2.BackupBatteryVoltage, stat2.BatteryChemistry,
                pflags, vectorptr(wv));

        Sleep(60000);
    }
}
