#include  <windows.h>
#include  <pkfuncs.h>
#include "debug.h"

void log_cell_info()
{
    WORD cellinfo[8][58];

    BOOL bMode = SetKMode(TRUE);
    DWORD dwPerm = SetProcPermissions(0xFFFFFFFF); 

    memcpy(cellinfo, (void*)0x8f1d8e78, sizeof(cellinfo));

    SetProcPermissions(dwPerm);
    SetKMode(bMode);  

    for (int cellix=0 ; cellix<8 ; cellix++) {
        debug("%d:", cellix);
        for (int param=0 ; param<58 ; param++) {
            debug(" %5d", cellinfo[cellix][param]);
        }
        debug("\n");
    }
    debug("\n");
}
int WINAPI WinMain( HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
    DebugSetLogfile("logcells.log");
    while (1) {
        log_cell_info();
        Sleep(5000);
    }

    return 0;
}

