/* Copyright 2005 xda-developers.com
 * All Rights Reserved
 *
 *  $Header: /var/db/cvs/xda-devtools/itsutils/common/FileFunctions.h,v 1.1 2005/04/05 13:21:50 itsme Exp $
 *
 */
#ifndef __FILEFUNCTIONS_H__

#include "vectorutils.h"
#include <string>

bool WriteFileData(const std::string& filename, const ByteVector& data);
bool LoadFileData(const std::string filename, ByteVector& data);
bool ReadDword(HANDLE f, DWORD &w);
bool ReadData(HANDLE f, ByteVector& data, DWORD size=0xFFFFFFFF);
bool WriteData(HANDLE f, const ByteVector& data);
bool WriteDword(HANDLE f, DWORD w);

#define __FILEFUNCTIONS_H__
#endif

