#!/bin/sh
date=`date +%y%m%d`
cvslog.bat |grep -v "^NEWDIR" | grep -v "^NEWFILE" >FullCvsLog
zip archive/itsutl$date.zip \
    build/*.dll \
    build/*.exe \
    dll/*.* \
    include/*.* \
    leds/*.* \
    libril/*.* \
    rilhook/*.* \
    src/*.* \
    old/*.* \
    tlbdump/*.* \
    *.* \
    */Makefile \
    README \
    ChangeLog \
    FullCvsLog \
    Makefile \
    common/*.* \
    extrom/*.*

zip -d archive/itsutl$date.zip \
    cesrc/Makefile \
    div/Makefile \
    loaderhook/Makefile \
    non-public/Makefile \
    tst/Makefile \
    tstaudio/Makefile \
    xda2dmp/Makefile \
    xda2unlock/Makefile \
    src/NKCOMPR.LIB \
    extrom/ExtendedROMUnlocker.arm.CAB \
    extrom/ExtendedROMUnlocker.arm.DAT \
    extrom/spcab.err \
    mkzip.bat \
    dotst.cmd \
    rilhook/ian_extend_dll_code.c \
    cesrc/saverom.cpp \
    dll/sprapiutils.cpp \
    leds/audiodev.cpp \
    leds/backup_wince.cpp \
    leds/backup_wince2.cpp \
    leds/opendisk.cpp \
    leds/openfile.cpp \
    leds/runbl.cpp \
    leds/saverom.cpp \
    leds/setdevdata.cpp \
    leds/tstbkl.cpp \
    leds/tstdb.cpp \
    leds/tstdsk.cpp \
    leds/tstetenapi.cpp \
    leds/tstpf.cpp \
    leds/tstreg.cpp \
    leds/tststores.cpp \
    leds/tsttffswork.cpp \
    old/kdebugdll.cpp \
    src/cedecomp.cpp \
    src/pcalladdr.cpp \
    src/pgsmbuf.cpp \
    src/pregdmp.cpp \
    src/pregutl2.cpp \
    src/pspipcdump.cpp \
    src/regutl_a.cpp \
    leds/trueffs.cpp-x \
    build/extendril.dll \
    build/sprapiutils.dll \
    build/autorun.exe \
    build/backup_wince.exe \
    build/backup_wince2.exe \
    build/batt.exe \
    build/cetstfilt.exe \
    build/hookapi.exe \
    build/ledtest.exe \
    build/loadrilextension.exe \
    build/openfile.exe \
    build/pcalladdr.exe \
    build/pcmon.exe \
    build/pflashrom.exe \
    build/pget2.exe \
    build/pgsmbuf.exe \
    build/pgsmdump.exe \
    build/pregdmp.exe \
    build/pspipcdump.exe \
    build/riltest.exe \
    build/setdevdata.exe \
    build/testpi.exe \
    build/tlbdump.exe \
    build/tsthid.exe \
    build/tsttffs.exe \
    build/unloadrilextension.exe \
    build/vibrate.exe \
    build/w32tstfilt.exe \
    common/templateutils.h \
    dll/sprapiutils.h \
    leds/audiodev.h \
    libril/ril-xdadev.h \
    old/cenk.h \
    leds/dotst.o \
    leds/sum.pl \
    old/cvipcdump.pl \
    old/make.pl \
    */xda2dmp.* \
    */[xyz].* \
    */tst.* \
    */*.log \
    */*.dat \
    */*.obj \
    */*.map \
    */*.lst \
    */*.mem \
    */*.nb* \
    */*.new \
    */*.vc[ob] \
    */*.old \
    */*.out \
    */*.raw \
    */*.pdb \
    */*.idb \
    */*.sw* \
    */*.txt \
    */*.zip \
    */a.exe \
    [xyz].* \
    tst.* \
    *.log \
    *.dat \
    *.obj \
    *.map \
    *.lst \
    *.mem \
    *.nb* \
    *.new \
    *.vc[ob] \
    *.old \
    *.out \
    *.raw \
    *.pdb \
    *.idb \
    *.sw* \
    *.txt \
    *.zip 

