#include <windows.h>
#include <stdio.h>

int main(int argc, char **argv)
{
    if (argc!=3) {
        printf("need high + low filetime\n");
        return 1;
    }
    FILETIME ft;
    ft.dwHighDateTime= strtoul(argv[1], 0, 0);
    ft.dwLowDateTime= strtoul(argv[2], 0, 0);

    SYSTEMTIME st;

    if (!FileTimeToSystemTime(&ft, &st)) {
        printf("ERROR %08lx\n", GetLastError());
        return 1;
    }

    printf("%04d-%02d-%02d %02d:%02d:%02d.%04d\n", 
        st.wYear, st.wMonth, st.wDay,
        st.wHour, st.wMinute, st.wSecond,
        st.wMilliseconds);

    return 0;
}
