/* (C) 2003 XDA Developers  itsme@xs4all.nl
 *
 * $Header: /var/db/cvs/xda-devtools/itsutils/src/preboot.cpp,v 1.2 2005/02/23 14:07:58 itsme Exp $
 */
#include <windows.h>
#include <rapi.h>

#include "debug.h"

#include "ItsUtils.h"
#include "dllversion.h"

void ITReboot();

int main( int argc, char *argv[])
{
    DebugStdOut();

    if (argc!=1)
    {
        printf("Usage: preboot\n");
        return 1;
    }

    CheckITSDll();

    ITReboot();

    CeRapiUninit();

    return 0;
}

void ITReboot()
{
    DWORD outsize=0;
    HRESULT res= CeRapiInvoke(L"\\Windows\\ItsUtils.dll", L"ITReboot",
            0, NULL, &outsize, NULL, NULL, 0);

    printf("result=%08lx\n", res);
}
